OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions
NWidgetSpacer Class Reference
Hierarchical widgets

Spacer widget. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetSpacer:

## Public Member Functions
| NWidgetSpacer (int length, int height)
| Generic spacer widget.
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
void | FillNestedArray (NWidgetBase **array, uint length)
void | Draw (const Window *w)
| Draw the widgets of the tree.
void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
Public Member Functions inherited from NWidgetResizeBase
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets.
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget.
void | SetMinimalTextLines (uint8 min_lines, uint8 spacing, FontSize size)
| Set minimal text lines for the widget.
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size.
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted (TextColour highlight_colour)
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Additional Inherited Members
Data Fields inherited from NWidgetResizeBase
uint | min_x
| Minimal horizontal size of only this widget.
uint | min_y
| Minimal vertical size of only this widget.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.

## Detailed Description

Spacer widget.

Definition at line 529 of file widget_type.h.

## Constructor & Destructor Documentation

NWidgetSpacer::NWidgetSpacer | ( | int | length,
|  | int | height
| ) |  |

Generic spacer widget.

Parameters

  length | Horizontal size of the spacer widget.
  height | Vertical size of the spacer widget.

Definition at line 1437 of file widget.cpp.

References NWidgetResizeBase::SetMinimalSize(), and NWidgetResizeBase::SetResize().

## Member Function Documentation

void NWidgetSpacer::Draw | ( | const Window * | w | ) |
| virtual

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1453 of file widget.cpp.

NWidgetCore * NWidgetSpacer::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| virtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Definition at line 1463 of file widget.cpp.

void NWidgetSpacer::SetDirty | ( | const Window * | w | ) | const
| virtual

Mark the widget as 'dirty' (in need of repaint).

Parameters

  w | Window owning the widget.

Reimplemented from NWidgetBase.

Definition at line 1458 of file widget.cpp.

void NWidgetSpacer::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| virtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1443 of file widget.cpp.

References NWidgetResizeBase::min_x, NWidgetResizeBase::min_y, NWidgetBase::smallest_x, and NWidgetBase::smallest_y.

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp